20259: Add documentation for banner and tooltip features
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -o pipefail
14
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
17
18 usage() {
19   echo >&2
20   echo >&2 "Usage: ${0} [-h] [-h]"
21   echo >&2
22   echo >&2 "${0} options:"
23   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
24   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
25   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
26   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
27   echo >&2 "                                              Possible values are:"
28   echo >&2 "                                                api"
29   echo >&2 "                                                controller"
30   echo >&2 "                                                dispatcher"
31   echo >&2 "                                                keepproxy"
32   echo >&2 "                                                keepbalance"
33   echo >&2 "                                                keepstore"
34   echo >&2 "                                                keepweb"
35   echo >&2 "                                                shell"
36   echo >&2 "                                                webshell"
37   echo >&2 "                                                websocket"
38   echo >&2 "                                                workbench"
39   echo >&2 "                                                workbench2"
40   echo >&2 "                                              Defaults to applying them all"
41   echo >&2 "  -h, --help                                  Display this help and exit"
42   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
43   echo >&2 "                                              This parameter does not perform any installation at all. It's"
44   echo >&2 "                                              intended to give you a parsed set of configuration files so"
45   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
46   echo >&2 "                                              It"
47   echo >&2 "                                                - parses the pillar and states templates,"
48   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
49   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
50   echo >&2 "                                                  for the selected role(s)"
51   echo >&2 "                                                - writes the resulting files into <dest_dir>"
52   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
53   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
54   echo >&2
55 }
56
57 arguments() {
58   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
59   if ! which getopt > /dev/null; then
60     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
61     exit 1
62   fi
63
64   TEMP=$(getopt -o c:dhp:r:tv \
65     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
66     -n "${0}" -- "${@}")
67
68   if [ ${?} != 0 ];
69     then echo "Please check the parameters you entered and re-run again"
70     exit 1
71   fi
72   # Note the quotes around `$TEMP': they are essential!
73   eval set -- "$TEMP"
74
75   while [ ${#} -ge 1 ]; do
76     case ${1} in
77       -c | --config)
78         CONFIG_FILE=${2}
79         shift 2
80         ;;
81       -d | --debug)
82         LOG_LEVEL="debug"
83         shift
84         set -x
85         ;;
86       --dump-config)
87         if [[ ${2} = /* ]]; then
88           DUMP_SALT_CONFIG_DIR=${2}
89         else
90           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
91         fi
92         ## states
93         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
94         ## formulas
95         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
96         ## pillars
97         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
98         ## tests
99         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
100         DUMP_CONFIG="yes"
101         shift 2
102         ;;
103       --development)
104         DEV_MODE="yes"
105         shift 1
106         ;;
107       -r | --roles)
108         for i in ${2//,/ }
109           do
110             # Verify the role exists
111             if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
112               echo "The role '${i}' is not a valid role"
113               usage
114               exit 1
115             fi
116             ROLES="${ROLES} ${i}"
117           done
118           shift 2
119         ;;
120       -t | --test)
121         TEST="yes"
122         shift
123         ;;
124       -v | --vagrant)
125         VAGRANT="yes"
126         shift
127         ;;
128       --)
129         shift
130         break
131         ;;
132       *)
133         usage
134         exit 1
135         ;;
136     esac
137   done
138 }
139
140 copy_custom_cert() {
141   cert_dir=${1}
142   cert_name=${2}
143
144   mkdir -p --mode=0700 /srv/salt/certs
145
146   if [ -f ${cert_dir}/${cert_name}.crt ]; then
147     install --mode=0600 ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
148   else
149     echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
150     exit 1
151   fi
152   if [ -f ${cert_dir}/${cert_name}.key ]; then
153     install --mode=0600 ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
154   else
155     echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
156     exit 1
157   fi
158 }
159
160 DEV_MODE="no"
161 CONFIG_FILE="${SCRIPT_DIR}/local.params"
162 CONFIG_DIR="local_config_dir"
163 DUMP_CONFIG="no"
164 LOG_LEVEL="info"
165 CONTROLLER_EXT_SSL_PORT=443
166 TESTS_DIR="tests"
167
168 NGINX_INSTALL_SOURCE="install_from_repo"
169
170 CLUSTER=""
171 DOMAIN=""
172
173 # Hostnames/IPs used for single-host deploys
174 IP_INT="127.0.1.1"
175
176 # Initial user setup
177 INITIAL_USER=""
178 INITIAL_USER_EMAIL=""
179 INITIAL_USER_PASSWORD=""
180
181 CONTROLLER_EXT_SSL_PORT=8000
182 KEEP_EXT_SSL_PORT=25101
183 # Both for collections and downloads
184 KEEPWEB_EXT_SSL_PORT=9002
185 WEBSHELL_EXT_SSL_PORT=4202
186 WEBSOCKET_EXT_SSL_PORT=8002
187 WORKBENCH1_EXT_SSL_PORT=443
188 WORKBENCH2_EXT_SSL_PORT=3001
189
190 SSL_MODE="self-signed"
191 USE_LETSENCRYPT_ROUTE53="no"
192 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/local_config_dir/certs"
193
194 ## These are ARVADOS-related parameters
195 # For a stable release, change RELEASE "production" and VERSION to the
196 # package version (including the iteration, e.g. X.Y.Z-1) of the
197 # release.
198 # The "local.params.example.*" files already set "RELEASE=production"
199 # to deploy  production-ready packages
200 RELEASE="development"
201 VERSION="latest"
202
203 # These are arvados-formula-related parameters
204 # An arvados-formula tag. For a stable release, this should be a
205 # branch name (e.g. X.Y-dev) or tag for the release.
206 # ARVADOS_TAG="2.2.0"
207 # BRANCH="main"
208
209 # We pin the salt version to avoid potential incompatibilities when a new
210 # stable version is released.
211 SALT_VERSION="3004"
212
213 # Other formula versions we depend on
214 #POSTGRES_TAG="v0.44.0"
215 #POSTGRES_URL="https://github.com/saltstack-formulas/postgres-formula.git"
216 POSTGRES_TAG="0.45.0-bugfix327"
217 POSTGRES_URL="https://github.com/arvados/postgres-formula.git"
218 NGINX_TAG="v2.8.1"
219 DOCKER_TAG="v2.4.2"
220 LOCALE_TAG="v0.3.4"
221 LETSENCRYPT_TAG="v2.1.0"
222 LOGROTATE_TAG="v0.14.0"
223
224 # Salt's dir
225 DUMP_SALT_CONFIG_DIR=""
226 ## states
227 S_DIR="/srv/salt"
228 ## formulas
229 F_DIR="/srv/formulas"
230 ## pillars
231 P_DIR="/srv/pillars"
232 ## tests
233 T_DIR="/tmp/cluster_tests"
234
235 arguments ${@}
236
237 declare -A NODES
238
239 if [ -s ${CONFIG_FILE} ]; then
240   source ${CONFIG_FILE}
241 else
242   echo >&2 "You don't seem to have a config file with initial values."
243   echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
244   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
245   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
246   exit 1
247 fi
248
249 if [ ! -d ${CONFIG_DIR} ]; then
250   echo >&2 "You don't seem to have a config directory with pillars and states."
251   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
252   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
253   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
254   exit 1
255 fi
256
257 if grep -rni 'fixme' ${CONFIG_FILE} ${CONFIG_DIR} ; then
258   echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
259   echo >&2 "Please, fix them and re-run the provision script."
260   exit 1
261 fi
262
263 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
264   echo >&2 "ERROR: <CLUSTER> must be exactly 5 lowercase alphanumeric characters long"
265   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
266   exit 1
267 fi
268
269 # Only used in single_host/single_name deploys
270 if [ ! -z "${HOSTNAME_EXT}" ] ; then
271   # We need to add some extra control vars to manage a single certificate vs. multiple
272   USE_SINGLE_HOSTNAME="yes"
273   # Make sure that the value configured as IP_INT is a real IP on the system.
274   # If we don't error out early here when there is a mismatch, the formula will
275   # fail with hard to interpret nginx errors later on.
276   ip addr list |grep "${IP_INT}/" >/dev/null
277   if [[ $? -ne 0 ]]; then
278     echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
279     exit 1
280   fi
281 else
282   USE_SINGLE_HOSTNAME="no"
283   # We set this variable, anyway, so sed lines do not fail and we don't need to add more
284   # conditionals
285   HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
286 fi
287
288 if [ "${DUMP_CONFIG}" = "yes" ]; then
289   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
290 else
291   # Install a few dependency packages
292   # First, let's figure out the OS we're working on
293   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
294   echo "Detected distro: ${OS_ID}"
295
296   case ${OS_ID} in
297     "centos")
298       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
299       sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
300       setenforce permissive
301       yum install -y  curl git jq
302       ;;
303     "debian"|"ubuntu")
304       # Wait 2 minutes for any apt locks to clear
305       # This option is supported from apt 1.9.1 and ignored in older apt versions.
306       # Cf. https://blog.sinjakli.co.uk/2021/10/25/waiting-for-apt-locks-without-the-hacky-bash-scripts/
307       DEBIAN_FRONTEND=noninteractive apt -o DPkg::Lock::Timeout=120 update
308       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
309       ;;
310   esac
311
312   if which salt-call; then
313     echo "Salt already installed"
314   else
315     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
316     sh /tmp/bootstrap_salt.sh -XdfP -x python3 stable ${SALT_VERSION}
317     /bin/systemctl stop salt-minion.service
318     /bin/systemctl disable salt-minion.service
319   fi
320
321   # Set salt to masterless mode
322   cat > /etc/salt/minion << EOFSM
323 failhard: "True"
324
325 file_client: local
326 file_roots:
327   base:
328     - ${S_DIR}
329     - ${F_DIR}/*
330
331 pillar_roots:
332   base:
333     - ${P_DIR}
334 EOFSM
335 fi
336
337 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
338
339 # Get the formula and dependencies
340 cd ${F_DIR} || exit 1
341 echo "Cloning formulas"
342 test -d docker && ( cd docker && git fetch ) \
343   || git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
344 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" )
345
346 echo "...locale"
347 test -d locale && ( cd locale && git fetch ) \
348   || git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
349 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" )
350
351 echo "...nginx"
352 test -d nginx && ( cd nginx && git fetch ) \
353   || git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
354 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" )
355
356 echo "...postgres"
357 test -d postgres && ( cd postgres && git fetch ) \
358   || git clone --quiet ${POSTGRES_URL} ${F_DIR}/postgres
359 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" )
360
361 echo "...letsencrypt"
362 test -d letsencrypt && ( cd letsencrypt && git fetch ) \
363   || git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
364 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" )
365
366 echo "...logrotate"
367 test -d logrotate && ( cd logrotate && git fetch ) \
368   || git clone --quiet https://github.com/saltstack-formulas/logrotate-formula.git ${F_DIR}/logrotate
369 ( cd logrotate && git checkout --quiet tags/"${LOGROTATE_TAG}" )
370
371 echo "...arvados"
372 test -d arvados || git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
373
374 # If we want to try a specific branch of the formula
375 if [ "x${BRANCH}" != "x" ]; then
376   ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
377 elif [ "x${ARVADOS_TAG}" != "x" ]; then
378   ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
379 fi
380
381 if [ "x${VAGRANT}" = "xyes" ]; then
382   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
383   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
384   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
385 else
386   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
387   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
388   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
389 fi
390
391 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
392
393 echo "Writing pillars and states"
394
395 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
396 # to ease deployment for newcomers
397 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
398   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
399   exit 1
400 fi
401 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
402   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
403        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
404        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
405        s#__CLUSTER__#${CLUSTER}#g;
406        s#__DOMAIN__#${DOMAIN}#g;
407        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
408        s#__IP_INT__#${IP_INT}#g;
409        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
410        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
411        s#__INITIAL_USER__#${INITIAL_USER}#g;
412        s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
413        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
414        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
415        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
416        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
417        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
418        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
419        s#__RELEASE__#${RELEASE}#g;
420        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
421        s#__VERSION__#${VERSION}#g;
422        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
423        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
424        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
425        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
426        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
427        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
428        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
429        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
430        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
431        s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
432        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
433        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
434        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
435        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
436        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
437        s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
438        s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g;
439        s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
440        s#__SSL_KEY_AWS_REGION__#${SSL_KEY_AWS_REGION}#g;
441        s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g" \
442   "${f}" > "${P_DIR}"/$(basename "${f}")
443 done
444
445 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
446   echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
447   if [ "x${TEST}" = "xyes" ]; then
448     echo "WARNING: Disabling tests for this installation."
449   fi
450   TEST="no"
451 else
452   mkdir -p ${T_DIR}
453   # Replace cluster and domain name in the test files
454   for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
455     FILTERS="s#__CLUSTER__#${CLUSTER}#g;
456          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
457          s#__DOMAIN__#${DOMAIN}#g;
458          s#__IP_INT__#${IP_INT}#g;
459          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
460          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
461          s#__INITIAL_USER__#${INITIAL_USER}#g;
462          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
463          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
464     if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
465       FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
466          $FILTERS"
467     fi
468     sed "$FILTERS" \
469       "${f}" > ${T_DIR}/$(basename "${f}")
470   done
471   chmod 755 ${T_DIR}/run-test.sh
472 fi
473
474 # Replace helper state files that differ from the formula's examples
475 if [ -d "${SOURCE_STATES_DIR}" ]; then
476   mkdir -p "${F_DIR}"/extra/extra
477
478   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
479     sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
480          s#__CLUSTER__#${CLUSTER}#g;
481          s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
482          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
483          s#__DOMAIN__#${DOMAIN}#g;
484          s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
485          s#__IP_INT__#${IP_INT}#g;
486          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
487          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
488          s#__INITIAL_USER__#${INITIAL_USER}#g;
489          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
490          s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
491          s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
492          s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
493          s#__RELEASE__#${RELEASE}#g;
494          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
495          s#__VERSION__#${VERSION}#g;
496          s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
497          s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
498          s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
499          s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
500          s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
501          s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
502          s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
503          s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
504          s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
505          s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
506          s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
507          s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
508          s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
509          s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
510          s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
511          s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
512          s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g;
513          s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
514          s#__SSL_KEY_AWS_REGION__#${SSL_KEY_AWS_REGION}#g;
515          s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g" \
516     "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
517   done
518 fi
519
520 # Now, we build the SALT states/pillars trees
521 # As we need to separate both states and pillars in case we want specific
522 # roles, we iterate on both at the same time
523
524 # States
525 cat > ${S_DIR}/top.sls << EOFTSLS
526 base:
527   '*':
528     - locale
529 EOFTSLS
530
531 # Pillars
532 cat > ${P_DIR}/top.sls << EOFPSLS
533 base:
534   '*':
535     - locale
536     - arvados
537 EOFPSLS
538
539 # States, extra states
540 if [ -d "${F_DIR}"/extra/extra ]; then
541   SKIP_SNAKE_OIL="snakeoil_certs"
542
543   if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
544     # In dev mode, we create some snake oil certs that we'll
545     # use as CUSTOM_CERTS, so we don't skip the states file.
546     # Same when using self-signed certificates.
547     SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
548   fi
549   for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
550   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
551   done
552   # Use byo or self-signed certificates
553   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
554     mkdir -p "${F_DIR}"/extra/extra/files
555   fi
556 fi
557
558 # If we want specific roles for a node, just add the desired states
559 # and its dependencies
560 if [ -z "${ROLES}" ]; then
561   # States
562   echo "    - nginx.passenger" >> ${S_DIR}/top.sls
563   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
564     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
565       grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - extra.aws_credentials" >> ${S_DIR}/top.sls
566     fi
567     grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
568   else
569     mkdir -p --mode=0700 /srv/salt/certs
570     if [ "${SSL_MODE}" = "bring-your-own" ]; then
571       # Copy certs to formula extra/files
572       install --mode=0600 ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
573       # We add the custom_certs state
574       grep -q "custom_certs" ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
575       if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
576         grep -q "ssl_key_encrypted" ${S_DIR}/top.sls || echo "    - extra.ssl_key_encrypted" >> ${S_DIR}/top.sls
577       fi
578     fi
579     # In self-signed mode, the certificate files will be created and put in the
580     # destination directory by the snakeoil_certs.sls state file
581   fi
582
583   echo "    - postgres" >> ${S_DIR}/top.sls
584   echo "    - logrotate" >> ${S_DIR}/top.sls
585   echo "    - docker.software" >> ${S_DIR}/top.sls
586   echo "    - arvados" >> ${S_DIR}/top.sls
587   echo "    - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
588   echo "    - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
589   echo "    - extra.passenger_rvm" >> ${S_DIR}/top.sls
590
591   # Pillars
592   echo "    - docker" >> ${P_DIR}/top.sls
593   echo "    - nginx_api_configuration" >> ${P_DIR}/top.sls
594   echo "    - logrotate_api" >> ${P_DIR}/top.sls
595   echo "    - nginx_controller_configuration" >> ${P_DIR}/top.sls
596   echo "    - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
597   echo "    - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
598   echo "    - nginx_passenger" >> ${P_DIR}/top.sls
599   echo "    - nginx_websocket_configuration" >> ${P_DIR}/top.sls
600   echo "    - nginx_webshell_configuration" >> ${P_DIR}/top.sls
601   echo "    - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
602   echo "    - nginx_workbench_configuration" >> ${P_DIR}/top.sls
603   echo "    - logrotate_wb1" >> ${P_DIR}/top.sls
604   echo "    - postgresql" >> ${P_DIR}/top.sls
605
606   # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
607   NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
608   sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
609
610   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
611     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
612       grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
613     fi
614     grep -q "letsencrypt" ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
615
616     hosts=("controller" "websocket" "workbench" "workbench2" "webshell" "keepproxy")
617     if [ ${USE_SINGLE_HOSTNAME} = "no" ]; then
618       hosts+=("download" "collections")
619     else
620       hosts+=("keepweb")
621     fi
622
623     for c in "${hosts[@]}"; do
624       # Are we in a single-host-single-hostname env?
625       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
626         # Are we in a single-host-single-hostname env?
627         CERT_NAME=${HOSTNAME_EXT}
628       else
629         # We are in a multiple-hostnames env
630         CERT_NAME=${c}.${CLUSTER}.${DOMAIN}
631       fi
632
633       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
634       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
635               s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
636               s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
637       ${P_DIR}/nginx_${c}_configuration.sls
638     done
639   else
640     # Use custom certs (either dev mode or prod)
641     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
642     # And add the certs in the custom_certs pillar
643     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
644     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
645
646     for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
647       # Are we in a single-host-single-hostname env?
648       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
649         # Are we in a single-host-single-hostname env?
650         CERT_NAME=${HOSTNAME_EXT}
651       else
652         # We are in a multiple-hostnames env
653         CERT_NAME=${c}
654       fi
655
656       if [[ "$SSL_MODE" == "bring-your-own" ]]; then
657         copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
658       fi
659
660       grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo "  - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
661
662       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
663       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
664               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
665               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
666       ${P_DIR}/nginx_${c}_configuration.sls
667     done
668   fi
669 else
670   # If we add individual roles, make sure we add the repo first
671   echo "    - arvados.repo" >> ${S_DIR}/top.sls
672   # We add the extra_custom_certs state
673   grep -q "extra.custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
674   if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
675     grep -q "ssl_key_encrypted" ${S_DIR}/top.sls || echo "    - extra.ssl_key_encrypted" >> ${S_DIR}/top.sls
676   fi
677
678   # And we add the basic part for the certs pillar
679   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
680     # And add the certs in the custom_certs pillar
681     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
682     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
683     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
684   fi
685
686   for R in ${ROLES}; do
687     case "${R}" in
688       "database")
689         # States
690         echo "    - postgres" >> ${S_DIR}/top.sls
691         # Pillars
692         echo '    - postgresql' >> ${P_DIR}/top.sls
693       ;;
694       "api")
695         # States
696         grep -q "    - logrotate" ${S_DIR}/top.sls || echo "    - logrotate" >> ${S_DIR}/top.sls
697         if grep -q "    - nginx.*$" ${S_DIR}/top.sls; then
698           sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
699         else
700           echo "    - nginx.passenger" >> ${S_DIR}/top.sls
701         fi
702         echo "    - extra.passenger_rvm" >> ${S_DIR}/top.sls
703         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
704         ### after it. So we add this here as we are, after all, sharing the host for api and controller
705         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
706           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
707             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
708           fi
709           grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
710         else
711           # Use custom certs
712           if [ "${SSL_MODE}" = "bring-your-own" ]; then
713             copy_custom_cert ${CUSTOM_CERTS_DIR} controller
714           fi
715           grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
716         fi
717         grep -q "arvados.${R}" ${S_DIR}/top.sls    || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
718         # Pillars
719         grep -q "logrotate_api" ${P_DIR}/top.sls            || echo "    - logrotate_api" >> ${P_DIR}/top.sls
720         grep -q "aws_credentials" ${P_DIR}/top.sls          || echo "    - aws_credentials" >> ${P_DIR}/top.sls
721         grep -q "postgresql" ${P_DIR}/top.sls               || echo "    - postgresql" >> ${P_DIR}/top.sls
722         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
723         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
724
725         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
726         NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
727         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
728       ;;
729       "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
730         # States
731         if [ "${R}" = "workbench" ]; then
732           grep -q "    - logrotate" ${S_DIR}/top.sls || echo "    - logrotate" >> ${S_DIR}/top.sls
733           NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
734           if grep -q "    - nginx$" ${S_DIR}/top.sls; then
735             sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
736           else
737             echo "    - nginx.passenger" >> ${S_DIR}/top.sls
738           fi
739         else
740           grep -q "nginx" ${S_DIR}/top.sls || echo "    - nginx" >> ${S_DIR}/top.sls
741         fi
742         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
743           if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
744             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
745           fi
746           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
747         else
748           # Use custom certs, special case for keepweb
749           if [ ${R} = "keepweb" ]; then
750             if [ "${SSL_MODE}" = "bring-your-own" ]; then
751               copy_custom_cert ${CUSTOM_CERTS_DIR} download
752               copy_custom_cert ${CUSTOM_CERTS_DIR} collections
753             fi
754           else
755             if [ "${SSL_MODE}" = "bring-your-own" ]; then
756               copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
757             fi
758           fi
759         fi
760         # webshell role is just a nginx vhost, so it has no state
761         if [ "${R}" != "webshell" ]; then
762           grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
763         fi
764         # Pillars
765         if [ "${R}" = "workbench" ]; then
766           grep -q "logrotate_wb1" ${P_DIR}/top.sls || echo "    - logrotate_wb1" >> ${P_DIR}/top.sls
767         fi
768         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
769         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
770         # Special case for keepweb
771         if [ ${R} = "keepweb" ]; then
772           grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo "    - nginx_download_configuration" >> ${P_DIR}/top.sls
773           grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo "    - nginx_collections_configuration" >> ${P_DIR}/top.sls
774         fi
775
776         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
777           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
778             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
779           fi
780           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
781           grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
782
783           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
784           # Special case for keepweb
785           if [ ${R} = "keepweb" ]; then
786             for kwsub in download collections; do
787               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
788                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
789                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
790               ${P_DIR}/nginx_${kwsub}_configuration.sls
791             done
792           else
793             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
794                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
795                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
796             ${P_DIR}/nginx_${R}_configuration.sls
797           fi
798         else
799           grep -q "ssl_key_encrypted" ${P_DIR}/top.sls || echo "    - ssl_key_encrypted" >> ${P_DIR}/top.sls
800           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
801           # Special case for keepweb
802           if [ ${R} = "keepweb" ]; then
803             for kwsub in download collections; do
804               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
805                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
806                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
807               ${P_DIR}/nginx_${kwsub}_configuration.sls
808               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
809             done
810           else
811             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
812                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
813                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
814             ${P_DIR}/nginx_${R}_configuration.sls
815             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
816           fi
817         fi
818         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
819         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
820       ;;
821       "shell")
822         # States
823         echo "    - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
824         echo "    - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
825         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
826         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
827         # Pillars
828         grep -q "docker" ${P_DIR}/top.sls       || echo "    - docker" >> ${P_DIR}/top.sls
829       ;;
830       "dispatcher" | "keepbalance" | "keepstore")
831         # States
832         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
833         # Pillars
834         # ATM, no specific pillar needed
835       ;;
836       *)
837         echo "Unknown role ${R}"
838         exit 1
839       ;;
840     esac
841   done
842 fi
843
844 if [ "${DUMP_CONFIG}" = "yes" ]; then
845   # We won't run the rest of the script because we're just dumping the config
846   exit 0
847 fi
848
849 # Now run the install
850 salt-call --state-output=mixed --local state.apply -l ${LOG_LEVEL}
851
852 # Finally, make sure that /etc/hosts is not overwritten on reboot
853 if [ -d /etc/cloud/cloud.cfg.d ]; then
854   # TODO: will this work on CentOS?
855   sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
856 fi
857
858 # Leave a copy of the Arvados CA so the user can copy it where it's required
859 if [ "${SSL_MODE}" = "self-signed" ]; then
860   echo "Copying the Arvados CA certificate '${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.crt' to the installer dir, so you can import it"
861   if [ "x${VAGRANT}" = "xyes" ]; then
862     cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
863   else
864     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.crt
865   fi
866 fi
867
868 if [ "x${VAGRANT}" = "xyes" ]; then
869     # If running in a vagrant VM, also add default user to docker group
870     echo "Adding the vagrant user to the docker group"
871     usermod -a -G docker vagrant
872 fi
873
874 # Test that the installation finished correctly
875 if [ "x${TEST}" = "xyes" ]; then
876   cd ${T_DIR}
877   # If we use RVM, we need to run this with it, or most ruby commands will fail
878   RVM_EXEC=""
879   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
880     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
881   fi
882   ${RVM_EXEC} ./run-test.sh
883 fi